/***********************************************
 * File		: include/linux/ktau/ktau_proc_external.h
 * Version	: $Id: ktau_proc_external.h,v 1.1 2006/11/12 01:24:48 anataraj Exp $
 ***********************************************/

#ifndef _KTAU_PROC_EXTERNAL_H
#define _KTAU_PROC_EXTERNAL_H

/* Stuff that is used by the 'direct' client *
 * of /proc/ktau -> the user-space library   *
 * i.e ktau_proc_interface.                  *
 */


#include "./ktau_datatype.h"
//#include <linux/ktau/ktau_datatype.h>



/* IOCTL Commands 		*
 * that are used by user-space  *
 * library to talk to ktau_proc *
 */

/* Create Commands Offset from a Magic-No */
#define KTAU_PROC_MAGIC(x)	(0xdeadbeef + (x))

#define CMD_SIZE              (KTAU_PROC_MAGIC(0)) 
#define CMD_READ              (KTAU_PROC_MAGIC(1))
#define CMD_PURGE             (KTAU_PROC_MAGIC(2))

#define CMD_ALL_SIZE          (KTAU_PROC_MAGIC(3))
#define CMD_ALL_READ          (KTAU_PROC_MAGIC(4))
#define CMD_ALL_PURGE         (KTAU_PROC_MAGIC(5))

#define CMD_SET_MERGE         (KTAU_PROC_MAGIC(6))

#define CMD_TRACE_SIZE              (KTAU_PROC_MAGIC(7)) 
#define CMD_TRACE_READ              (KTAU_PROC_MAGIC(8))
#define CMD_TRACE_PURGE             (KTAU_PROC_MAGIC(9))

#define CMD_ALL_TRACE_SIZE          (KTAU_PROC_MAGIC(10))
#define CMD_ALL_TRACE_READ          (KTAU_PROC_MAGIC(11))
#define CMD_ALL_TRACE_PURGE         (KTAU_PROC_MAGIC(12))

#define CMD_TRACE_RESIZE         (KTAU_PROC_MAGIC(13))
#define CMD_ALL_TRACE_RESIZE         (KTAU_PROC_MAGIC(14))

/* specifies the format of data that is got
 * from reading /proc/ktau/<pid> or /proc/ktau/all.
 *
 * 1st Field: unsigned long no_of_profiles
 * 		: tells the number of profiles to be expected (is always 1 when reading /proc/ktau/<pid>
 *
 * {From below repeats <no_profiles> times}
 *
 * 2nd Field: unsigned long no_of_entries in current profile
 * 		: tells how many 'profile entries' (i.e one each for a func/counter/event etc for current profile/pid
 *
 * 3-to-<no_of_entries + 3> Fields: profile_entry entry
 *
*/

typedef h_ent profile_entry;
	

#endif  /*_KTAU_PROC_EXTERNAL_H */
